Index: LMDZ6/branches/Amaury_dev/libf/misc/lmdz_pres2lev.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/misc/lmdz_pres2lev.f90	(revision 5117)
+++ LMDZ6/branches/Amaury_dev/libf/misc/lmdz_pres2lev.f90	(revision 5117)
@@ -0,0 +1,81 @@
+! $Id: pres2lev.F 1179 2009-06-11 14:18:47Z jghattas $
+
+MODULE lmdz_pres2lev
+  IMPLICIT NONE; PRIVATE
+  PUBLIC pres2lev
+
+CONTAINS
+
+  !******************************************************
+  SUBROUTINE pres2lev(varo, varn, lmo, lmn, po, pn, ni, nj, ok_invertp)
+
+    ! interpolation lineaire pour passer
+    ! a une nouvelle discretisation verticale pour
+    ! les variables de GCM
+    ! Francois Forget (01/1995)
+    ! MOdif remy roca 12/97 pour passer de pres2sig
+    ! Modif F.Codron 07/08 po en 3D
+    !**********************************************************
+
+    IMPLICIT NONE
+
+    !   Declarations:
+    ! ==============
+
+    !  ARGUMENTS
+    !  """""""""
+    LOGICAL, INTENT(IN) :: ok_invertp
+    INTEGER, INTENT(IN) :: lmo ! dimensions ancienne couches
+    INTEGER, INTENT(IN) :: lmn ! dimensions nouvelle couches
+
+    INTEGER, INTENT(IN) :: ni, nj ! nombre de point horizontal
+    REAL, INTENT(IN) :: po(ni * nj, lmo) ! niveau de pression ancienne grille
+    REAL, INTENT(IN) :: pn(ni * nj, lmn) ! niveau de pression nouvelle grille
+
+    REAL, INTENT(IN) :: varo(ni * nj, lmo) ! var dans l'ancienne grille
+    REAL, INTENT(OUT) :: varn(ni * nj, lmn) ! var dans la nouvelle grille
+
+    REAL :: zvaro(ni * nj, lmo), zpo(ni * nj, lmo)
+
+    ! Autres variables
+    ! """"""""""""""""
+    INTEGER :: ln, lo, k
+    REAL :: coef
+
+
+    ! Inversion de l'ordre des niveaux verticaux
+    IF (ok_invertp) THEN
+      DO lo = 1, lmo
+        DO k = 1, ni * nj
+          zpo(k, lo) = po(k, lmo + 1 - lo)
+          zvaro(k, lo) = varo(k, lmo + 1 - lo)
+        ENDDO
+      ENDDO
+    ELSE
+      DO lo = 1, lmo
+        DO k = 1, ni * nj
+          zpo(k, lo) = po(k, lo)
+          zvaro(k, lo) = varo(k, lo)
+        ENDDO
+      ENDDO
+    ENDIF
+
+    DO ln = 1, lmn
+      DO lo = 1, lmo - 1
+        DO k = 1, ni * nj
+          IF (pn(k, ln) >= zpo(k, 1)) THEN
+            varn(k, ln) = zvaro(k, 1)
+          ELSE IF (pn(k, ln) <= zpo(k, lmo)) THEN
+            varn(k, ln) = zvaro(k, lmo)
+          ELSE IF (pn(k, ln) <= zpo(k, lo) .AND. pn(k, ln) > zpo(k, lo + 1)) THEN
+            coef = (pn(k, ln) - zpo(k, lo)) / (zpo(k, lo + 1) - zpo(k, lo))
+            varn(k, ln) = zvaro(k, lo) + coef * (zvaro(k, lo + 1) - zvaro(k, lo))
+          ENDIF
+
+        ENDDO
+      ENDDO
+    ENDDO
+
+  END SUBROUTINE pres2lev
+
+END MODULE lmdz_pres2lev
Index: LMDZ6/branches/Amaury_dev/libf/misc/lmdz_q_sat.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/misc/lmdz_q_sat.f90	(revision 5117)
+++ LMDZ6/branches/Amaury_dev/libf/misc/lmdz_q_sat.f90	(revision 5117)
@@ -0,0 +1,70 @@
+! $Header$
+
+MODULE lmdz_q_sat
+  IMPLICIT NONE; PRIVATE
+  PUBLIC q_sat
+CONTAINS
+  SUBROUTINE q_sat(np, temp, pres, qsat)
+
+    IMPLICIT NONE
+    !======================================================================
+    ! Autheur(s): Z.X. Li (LMD/CNRS)
+    !  reecriture vectorisee par F. Hourdin.
+    ! Objet: calculer la vapeur d'eau saturante (formule Centre Euro.)
+    !======================================================================
+    ! Arguments:
+    ! kelvin---input-R: temperature en Kelvin
+    ! millibar--input-R: pression en mb
+
+    ! q_sat----output-R: vapeur d'eau saturante en kg/kg
+    !======================================================================
+
+    INTEGER :: np
+    REAL :: temp(np), pres(np), qsat(np)
+
+    REAL :: r2es
+    PARAMETER (r2es = 611.14 * 18.0153 / 28.9644)
+
+    REAL :: r3les, r3ies, r3es
+    PARAMETER (R3LES = 17.269)
+    PARAMETER (R3IES = 21.875)
+
+    REAL :: r4les, r4ies, r4es
+    PARAMETER (R4LES = 35.86)
+    PARAMETER (R4IES = 7.66)
+
+    REAL :: rtt
+    PARAMETER (rtt = 273.16)
+
+    REAL :: retv
+    PARAMETER (retv = 28.9644 / 18.0153 - 1.0)
+
+    REAL :: zqsat
+    INTEGER :: ip
+
+    ! ------------------------------------------------------------------
+
+    do ip = 1, np
+
+      ! WRITE(*,*)'kelvin,millibar=',kelvin,millibar
+      !  WRITE(*,*)'temp,pres=',temp(ip),pres(ip)
+
+      IF (temp(ip) <= rtt) THEN
+        r3es = r3ies
+        r4es = r4ies
+      ELSE
+        r3es = r3les
+        r4es = r4les
+      END IF
+
+      zqsat = r2es / pres(ip) * EXP(r3es * (temp(ip) - rtt) / (temp(ip) - r4es))
+      zqsat = MIN(0.5, ZQSAT)
+      zqsat = zqsat / (1. - retv * zqsat)
+
+      qsat(ip) = zqsat
+      ! WRITE(*,*)'qsat=',qsat(ip)
+
+    END DO
+
+  END SUBROUTINE q_sat
+END MODULE lmdz_q_sat
Index: LMDZ6/branches/Amaury_dev/libf/misc/lmdz_ran1.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/misc/lmdz_ran1.f90	(revision 5117)
+++ LMDZ6/branches/Amaury_dev/libf/misc/lmdz_ran1.f90	(revision 5117)
@@ -0,0 +1,43 @@
+! $Id$
+
+MODULE lmdz_ran1
+  IMPLICIT NONE; PRIVATE
+  PUBLIC ran1
+CONTAINS
+
+  FUNCTION RAN1(IDUM)
+    IMPLICIT NONE
+    REAL :: RAN1
+    REAL, SAVE :: R(97)
+    REAL, PARAMETER :: RM1 = 3.8580247E-6, RM2 = 7.4373773E-6
+    INTEGER, SAVE :: IFF = 0
+    INTEGER, save :: ix1, ix2, ix3
+    INTEGER, PARAMETER :: M1 = 259200, IA1 = 7141, IC1 = 54773
+    INTEGER, PARAMETER :: M2 = 134456, IA2 = 8121, IC2 = 28411
+    INTEGER, PARAMETER :: M3 = 243000, IA3 = 4561, IC3 = 51349
+    INTEGER :: IDUM, J
+
+    IF (IDUM<0.OR.IFF==0) THEN
+      IFF = 1
+      IX1 = MOD(IC1 - IDUM, M1)
+      IX1 = MOD(IA1 * IX1 + IC1, M1)
+      IX2 = MOD(IX1, M2)
+      IX1 = MOD(IA1 * IX1 + IC1, M1)
+      IX3 = MOD(IX1, M3)
+      DO J = 1, 97
+        IX1 = MOD(IA1 * IX1 + IC1, M1)
+        IX2 = MOD(IA2 * IX2 + IC2, M2)
+        R(J) = (REAL(IX1) + REAL(IX2) * RM2) * RM1
+      END DO
+      IDUM = 1
+    ENDIF
+    IX1 = MOD(IA1 * IX1 + IC1, M1)
+    IX2 = MOD(IA2 * IX2 + IC2, M2)
+    IX3 = MOD(IA3 * IX3 + IC3, M3)
+    J = 1 + (97 * IX3) / M3
+    IF(J>97.OR.J<1) stop 1
+    RAN1 = R(J)
+    R(J) = (REAL(IX1) + REAL(IX2) * RM2) * RM1
+
+  END FUNCTION RAN1
+END MODULE lmdz_ran1
Index: LMDZ6/branches/Amaury_dev/libf/misc/lmdz_regr_conserv.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/misc/lmdz_regr_conserv.f90	(revision 5117)
+++ LMDZ6/branches/Amaury_dev/libf/misc/lmdz_regr_conserv.f90	(revision 5117)
@@ -0,0 +1,388 @@
+MODULE lmdz_regr_conserv
+
+  USE lmdz_assert_eq,   ONLY: assert_eq
+  USE lmdz_assert,      ONLY: assert
+  USE lmdz_interpolation, ONLY: locate
+
+  IMPLICIT NONE
+
+! Purpose: Each procedure regrids a piecewise linear function (not necessarily
+!          continuous) by averaging it. This is a conservative regridding.
+!          The regridding operation is done along dimension "ix" of the input
+!          field "vs". Input are positions of cell edges.
+! Remarks:
+!   * The target grid should be included in the source grid:
+!     no extrapolation is allowed.
+!   * Field on target grid "vt" has same rank, slopes and averages as "vs".
+!   * If optional argument "slope" is not given, 0 is assumed for slopes.
+!     Then the regridding is first order instead of second.
+!   * "vs" and "vt" have the same dimensions except Nr. ix (ns for vs, nt for vt)
+
+! Argument                         Type         Description
+!-------------------------------------------------------------------------------
+!  INTEGER, INTENT(IN)  :: ix      Scalar       dimension regridded <=rank(vs)
+!  REAL,    INTENT(IN)  :: vs(*)   Rank>=1      averages in source grid cells
+!  REAL,    INTENT(IN)  :: xs(:)   Vector(ns+1) edges of source grid, asc. order
+!  REAL,    INTENT(IN)  :: xt(:)   Vector(nt+1) edges of target grid, asc. order
+!  REAL,    INTENT(OUT) :: vt(*)   Rank>=1      regridded field
+! [REAL,    INTENT(IN)  :: slope]  Rank>=1      slopes in source grid cells
+
+  INTERFACE regr_conserv
+    ! The procedures differ only from the rank of the input/output fields.
+    MODULE PROCEDURE regr1_conserv, regr2_conserv, regr3_conserv, &
+                     regr4_conserv, regr5_conserv
+  END INTERFACE
+
+  PRIVATE
+  PUBLIC :: regr_conserv
+
+CONTAINS
+
+!-------------------------------------------------------------------------------
+
+SUBROUTINE regr1_conserv(ix, vs, xs, xt, vt, slope)
+
+!-------------------------------------------------------------------------------
+! Arguments:
+  INTEGER,        INTENT(IN)  :: ix
+  REAL,           INTENT(IN)  :: vs(:)
+  REAL,           INTENT(IN)  :: xs(:), xt(:)
+  REAL,           INTENT(OUT) :: vt(:)
+  REAL, OPTIONAL, INTENT(IN)  :: slope(:)
+!-------------------------------------------------------------------------------
+! Local variables:
+  INTEGER :: is, it, ns, nt
+  REAL    :: co, idt
+  LOGICAL :: lslope
+!-------------------------------------------------------------------------------
+  lslope=PRESENT(slope)
+  CALL check_size(ix,SHAPE(vs),SHAPE(vt),xs,xt,ns,nt)
+  is=locate(xs,xt(1))                    !--- 1<= is <= ns (no extrapolation)
+  vt(:)=0.
+  DO it=1, nt; idt=1./(xt(it+1)-xt(it))
+    IF(xt(it+1)<=xs(is+1)) THEN          !--- xs(is)<=xt(it)<=xt(it+1)<=xs(is+1)
+      CALL mean_lin(xt(it),xt(it+1))
+    ELSE
+      CALL mean_lin(xt(it),xs(is+1)); is=is+1
+      DO WHILE(xs(is+1)<xt(it+1))        !--- 1<=is<=ns-1
+      CALL mean_lin(xs(is),xs(is+1)); is=is+1
+      END DO
+      CALL mean_lin(xs(is),xt(it+1))     !--- 1<=is<=ns
+    END IF
+    IF(xs(is+1)==xt(it+1)) is=is+1       !--- 1<=is<=ns .OR. it==nt
+  END DO
+
+CONTAINS
+
+!-------------------------------------------------------------------------------
+SUBROUTINE mean_lin(a,b)  ! mean [a,b] of the linear function in [xs(is),xs(is+1)]
+!-------------------------------------------------------------------------------
+! Arguments:
+  REAL, INTENT(IN)    :: a, b
+!-------------------------------------------------------------------------------
+  IF(lslope.AND.(a/=xs(is).OR.b/=xs(is+1))) THEN; co=0.
+    IF(a==xt(it  )) co=co+xt(it  )-xs(is  )
+    IF(b==xt(it+1)) co=co+xt(it+1)-xs(is+1)
+    vt(it) = vt(it)+idt*(b-a)*(vs(is)+co*slope(is)/2.)
+  ELSE
+    vt(it) = vt(it)+idt*(b-a)* vs(is)
+  END IF
+
+END SUBROUTINE mean_lin
+!-------------------------------------------------------------------------------
+
+END SUBROUTINE regr1_conserv
+
+!-------------------------------------------------------------------------------
+
+
+!-------------------------------------------------------------------------------
+
+SUBROUTINE regr2_conserv(ix, vs, xs, xt, vt, slope)
+
+!-------------------------------------------------------------------------------
+! Arguments:
+  INTEGER,        INTENT(IN)  :: ix
+  REAL,           INTENT(IN)  :: vs(:,:)
+  REAL,           INTENT(IN)  :: xs(:), xt(:)
+  REAL,           INTENT(OUT) :: vt(:,:)
+  REAL, OPTIONAL, INTENT(IN)  :: slope(:,:)
+!-------------------------------------------------------------------------------
+! Local variables:
+  INTEGER :: is, it, ns, nt
+  REAL    :: co, idt
+  LOGICAL :: lslope
+!-------------------------------------------------------------------------------
+  lslope=PRESENT(slope)
+  CALL check_size(ix,SHAPE(vs),SHAPE(vt),xs,xt,ns,nt)
+  is=locate(xs,xt(1)) ! 1 <= is <= ns, because we forbid extrapolation
+  vt(:,:)=0.
+  DO it=1, nt; idt=1./(xt(it+1)-xt(it))
+    IF(xt(it+1)<=xs(is+1)) THEN          !--- xs(is)<=xt(it)<=xt(it+1)<=xs(is+1)
+      CALL mean_lin(xt(it),xt(it+1))
+    ELSE
+      CALL mean_lin(xt(it),xs(is+1)); is=is+1
+      DO WHILE(xs(is+1)<xt(it+1))        !--- 1<=is<=ns-1
+      CALL mean_lin(xs(is),xs(is+1)); is=is+1
+      END DO
+      CALL mean_lin(xs(is),xt(it+1))     !--- 1<=is<=ns
+    END IF
+    IF(xs(is+1)==xt(it+1)) is=is+1       !--- 1<=is<=ns .OR. it==nt
+  END DO
+
+CONTAINS
+
+!-------------------------------------------------------------------------------
+SUBROUTINE mean_lin(a,b)  ! mean [a,b] of the linear function in [xs(is),xs(is+1)]
+!-------------------------------------------------------------------------------
+! Arguments:
+  REAL, INTENT(IN)    :: a, b
+!-------------------------------------------------------------------------------
+  IF(lslope.AND.(a/=xs(is).OR.b/=xs(is+1))) THEN; co=0.
+    IF(a==xt(it  )) co=co+xt(it  )-xs(is  )
+    IF(b==xt(it+1)) co=co+xt(it+1)-xs(is+1)
+    IF(ix==1) vt(it,:) = vt(it,:)+idt*(b-a)*(vs(is,:)+co*slope(is,:)/2.)
+    IF(ix==2) vt(:,it) = vt(:,it)+idt*(b-a)*(vs(:,is)+co*slope(:,is)/2.)
+  ELSE
+    IF(ix==1) vt(it,:) = vt(it,:)+idt*(b-a)* vs(is,:)
+    IF(ix==2) vt(:,it) = vt(:,it)+idt*(b-a)* vs(:,is)
+  END IF
+
+END SUBROUTINE mean_lin
+!-------------------------------------------------------------------------------
+
+END SUBROUTINE regr2_conserv
+
+!-------------------------------------------------------------------------------
+
+
+!-------------------------------------------------------------------------------
+
+SUBROUTINE regr3_conserv(ix, vs, xs, xt, vt, slope)
+
+!-------------------------------------------------------------------------------
+! Arguments:
+  INTEGER,        INTENT(IN)  :: ix
+  REAL,           INTENT(IN)  :: vs(:,:,:)
+  REAL,           INTENT(IN)  :: xs(:), xt(:)
+  REAL,           INTENT(OUT) :: vt(:,:,:)
+  REAL, OPTIONAL, INTENT(IN)  :: slope(:,:,:)
+!-------------------------------------------------------------------------------
+! Local variables:
+  INTEGER :: is, it, ns, nt
+  REAL    :: co, idt
+  LOGICAL :: lslope
+!-------------------------------------------------------------------------------
+  lslope=PRESENT(slope)
+  CALL check_size(ix,SHAPE(vs),SHAPE(vt),xs,xt,ns,nt)
+  is=locate(xs,xt(1)) ! 1 <= is <= ns, because we forbid extrapolation
+  vt(:,:,:)=0.
+  DO it=1, nt; idt=1./(xt(it+1)-xt(it))
+    IF(xt(it+1)<=xs(is+1)) THEN          !--- xs(is)<=xt(it)<=xt(it+1)<=xs(is+1)
+      CALL mean_lin(xt(it),xt(it+1))
+    ELSE
+      CALL mean_lin(xt(it),xs(is+1)); is=is+1
+      DO WHILE(xs(is+1)<xt(it+1))        !--- 1<=is<=ns-1
+      CALL mean_lin(xs(is),xs(is+1)); is=is+1
+      END DO
+      CALL mean_lin(xs(is),xt(it+1))     !--- 1<=is<=ns
+    END IF
+    IF(xs(is+1)==xt(it+1)) is=is+1       !--- 1<=is<=ns .OR. it==nt
+  END DO
+
+CONTAINS
+
+!-------------------------------------------------------------------------------
+SUBROUTINE mean_lin(a,b)  ! mean [a,b] of the linear function in [xs(is),xs(is+1)]
+!-------------------------------------------------------------------------------
+! Arguments:
+  REAL, INTENT(IN)    :: a, b
+!-------------------------------------------------------------------------------
+  IF(lslope.AND.(a/=xs(is).OR.b/=xs(is+1))) THEN; co=0.
+    IF(a==xt(it  )) co=co+xt(it  )-xs(is  )
+    IF(b==xt(it+1)) co=co+xt(it+1)-xs(is+1)
+    IF(ix==1) vt(it,:,:) = vt(it,:,:)+idt*(b-a)*(vs(is,:,:)+co*slope(is,:,:)/2.)
+    IF(ix==2) vt(:,it,:) = vt(:,it,:)+idt*(b-a)*(vs(:,is,:)+co*slope(:,is,:)/2.)
+    IF(ix==3) vt(:,:,it) = vt(:,:,it)+idt*(b-a)*(vs(:,:,is)+co*slope(:,:,is)/2.)
+  ELSE
+    IF(ix==1) vt(it,:,:) = vt(it,:,:)+idt*(b-a)* vs(is,:,:)
+    IF(ix==2) vt(:,it,:) = vt(:,it,:)+idt*(b-a)* vs(:,is,:)
+    IF(ix==3) vt(:,:,it) = vt(:,:,it)+idt*(b-a)* vs(:,:,is)
+  END IF
+
+END SUBROUTINE mean_lin
+!-------------------------------------------------------------------------------
+
+END SUBROUTINE regr3_conserv
+
+!-------------------------------------------------------------------------------
+
+
+!-------------------------------------------------------------------------------
+
+SUBROUTINE regr4_conserv(ix, vs, xs, xt, vt, slope)
+
+!-------------------------------------------------------------------------------
+! Arguments:
+  INTEGER,        INTENT(IN)  :: ix
+  REAL,           INTENT(IN)  :: vs(:,:,:,:)
+  REAL,           INTENT(IN)  :: xs(:), xt(:)
+  REAL,           INTENT(OUT) :: vt(:,:,:,:)
+  REAL, OPTIONAL, INTENT(IN)  :: slope(:,:,:,:)
+!-------------------------------------------------------------------------------
+! Local variables:
+  INTEGER :: is, it, ns, nt
+  REAL    :: co, idt
+  LOGICAL :: lslope
+!-------------------------------------------------------------------------------
+  lslope=PRESENT(slope)
+  CALL check_size(ix,SHAPE(vs),SHAPE(vt),xs,xt,ns,nt)
+  is=locate(xs,xt(1)) ! 1 <= is <= ns, because we forbid extrapolation
+  vt(:,:,:,:)=0.
+  DO it=1, nt; idt=1./(xt(it+1)-xt(it))
+    IF(xt(it+1)<=xs(is+1)) THEN          !--- xs(is)<=xt(it)<=xt(it+1)<=xs(is+1)
+      CALL mean_lin(xt(it),xt(it+1))
+    ELSE
+      CALL mean_lin(xt(it),xs(is+1)); is=is+1
+      DO WHILE(xs(is+1)<xt(it+1))        !--- 1<=is<=ns-1
+      CALL mean_lin(xs(is),xs(is+1)); is=is+1
+      END DO
+      CALL mean_lin(xs(is),xt(it+1))     !--- 1<=is<=ns
+    END IF
+    IF(xs(is+1)==xt(it+1)) is=is+1       !--- 1<=is<=ns .OR. it==nt
+  END DO
+
+CONTAINS
+
+!-------------------------------------------------------------------------------
+SUBROUTINE mean_lin(a,b)  ! mean [a,b] of the linear function in [xs(is),xs(is+1)]
+!-------------------------------------------------------------------------------
+! Arguments:
+  REAL, INTENT(IN) :: a, b
+!-------------------------------------------------------------------------------
+  IF(lslope.AND.(a/=xs(is).OR.b/=xs(is+1))) THEN; co=0.
+    IF(a==xt(it  )) co=co+xt(it  )-xs(is  )
+    IF(b==xt(it+1)) co=co+xt(it+1)-xs(is+1)
+    IF(ix==1) vt(it,:,:,:) = vt(it,:,:,:)+idt*(b-a)*(vs(is,:,:,:)+co*slope(is,:,:,:)/2.)
+    IF(ix==2) vt(:,it,:,:) = vt(:,it,:,:)+idt*(b-a)*(vs(:,is,:,:)+co*slope(:,is,:,:)/2.)
+    IF(ix==3) vt(:,:,it,:) = vt(:,:,it,:)+idt*(b-a)*(vs(:,:,is,:)+co*slope(:,:,is,:)/2.)
+    IF(ix==4) vt(:,:,:,it) = vt(:,:,:,it)+idt*(b-a)*(vs(:,:,:,is)+co*slope(:,:,:,is)/2.)
+  ELSE
+    IF(ix==1) vt(it,:,:,:) = vt(it,:,:,:)+idt*(b-a)* vs(is,:,:,:)
+    IF(ix==2) vt(:,it,:,:) = vt(:,it,:,:)+idt*(b-a)* vs(:,is,:,:)
+    IF(ix==3) vt(:,:,it,:) = vt(:,:,it,:)+idt*(b-a)* vs(:,:,is,:)
+    IF(ix==4) vt(:,:,:,it) = vt(:,:,:,it)+idt*(b-a)* vs(:,:,:,is)
+  END IF
+
+END SUBROUTINE mean_lin
+!-------------------------------------------------------------------------------
+
+END SUBROUTINE regr4_conserv
+
+!-------------------------------------------------------------------------------
+
+
+!-------------------------------------------------------------------------------
+
+SUBROUTINE regr5_conserv(ix, vs, xs, xt, vt, slope)
+
+!-------------------------------------------------------------------------------
+! Arguments:
+  INTEGER,        INTENT(IN)  :: ix
+  REAL,           INTENT(IN)  :: vs(:,:,:,:,:)
+  REAL,           INTENT(IN)  :: xs(:), xt(:)
+  REAL,           INTENT(OUT) :: vt(:,:,:,:,:)
+  REAL, OPTIONAL, INTENT(IN)  :: slope(:,:,:,:,:)
+!-------------------------------------------------------------------------------
+! Local variables:
+  INTEGER :: is, it, ns, nt
+  REAL    :: co, idt
+  LOGICAL :: lslope
+!-------------------------------------------------------------------------------
+  lslope=PRESENT(slope)
+  CALL check_size(ix,SHAPE(vs),SHAPE(vt),xs,xt,ns,nt)
+  is=locate(xs,xt(1)) ! 1 <= is <= ns, because we forbid extrapolation
+  vt(:,:,:,:,:)=0.
+  DO it=1, nt; idt=1./(xt(it+1)-xt(it))
+    IF(xt(it+1)<=xs(is+1)) THEN          !--- xs(is)<=xt(it)<=xt(it+1)<=xs(is+1)
+      CALL mean_lin(xt(it),xt(it+1))
+    ELSE
+      CALL mean_lin(xt(it),xs(is+1)); is=is+1
+      DO WHILE(xs(is+1)<xt(it+1))        !--- 1<=is<=ns-1
+      CALL mean_lin(xs(is),xs(is+1)); is=is+1
+      END DO
+      CALL mean_lin(xs(is),xt(it+1))     !--- 1<=is<=ns
+    END IF
+    IF(xs(is+1)==xt(it+1)) is=is+1     !--- 1<=is<=ns .OR. it==nt
+  END DO
+
+CONTAINS
+
+!-------------------------------------------------------------------------------
+SUBROUTINE mean_lin(a,b)  ! mean [a,b] of the linear function in [xs(is),xs(is+1)]
+!-------------------------------------------------------------------------------
+! Arguments:
+  REAL, INTENT(IN) :: a, b
+!-------------------------------------------------------------------------------
+  IF(lslope.AND.(a/=xs(is).OR.b/=xs(is+1))) THEN; co=0.
+    IF(a==xt(it  )) co=co+xt(it  )-xs(is  )
+    IF(b==xt(it+1)) co=co+xt(it+1)-xs(is+1)
+    IF(ix==1) vt(it,:,:,:,:) = vt(it,:,:,:,:)+idt*(b-a)*(vs(is,:,:,:,:)+co*slope(is,:,:,:,:)/2.)
+    IF(ix==2) vt(:,it,:,:,:) = vt(:,it,:,:,:)+idt*(b-a)*(vs(:,is,:,:,:)+co*slope(:,is,:,:,:)/2.)
+    IF(ix==3) vt(:,:,it,:,:) = vt(:,:,it,:,:)+idt*(b-a)*(vs(:,:,is,:,:)+co*slope(:,:,is,:,:)/2.)
+    IF(ix==4) vt(:,:,:,it,:) = vt(:,:,:,it,:)+idt*(b-a)*(vs(:,:,:,is,:)+co*slope(:,:,:,is,:)/2.)
+    IF(ix==5) vt(:,:,:,:,it) = vt(:,:,:,:,it)+idt*(b-a)*(vs(:,:,:,:,is)+co*slope(:,:,:,:,is)/2.)
+  ELSE
+    IF(ix==1) vt(it,:,:,:,:) = vt(it,:,:,:,:)+idt*(b-a)* vs(is,:,:,:,:)
+    IF(ix==2) vt(:,it,:,:,:) = vt(:,it,:,:,:)+idt*(b-a)* vs(:,is,:,:,:)
+    IF(ix==3) vt(:,:,it,:,:) = vt(:,:,it,:,:)+idt*(b-a)* vs(:,:,is,:,:)
+    IF(ix==4) vt(:,:,:,it,:) = vt(:,:,:,it,:)+idt*(b-a)* vs(:,:,:,is,:)
+    IF(ix==5) vt(:,:,:,:,it) = vt(:,:,:,:,it)+idt*(b-a)* vs(:,:,:,:,is)
+  END IF
+
+END SUBROUTINE mean_lin
+!-------------------------------------------------------------------------------
+
+END SUBROUTINE regr5_conserv
+
+!-------------------------------------------------------------------------------
+
+
+!-------------------------------------------------------------------------------
+
+SUBROUTINE check_size(ix,svs,svt,xs,xt,ns,nt)
+
+!-------------------------------------------------------------------------------
+! Arguments:
+  INTEGER, INTENT(IN)  :: ix, svs(:), svt(:)
+  REAL,    INTENT(IN)  :: xs(:), xt(:)
+  INTEGER, INTENT(OUT) :: ns,    nt
+!-------------------------------------------------------------------------------
+! Local variables:
+  INTEGER :: rk, is, ii, n
+  CHARACTER(LEN=80) :: sub, msg
+!-------------------------------------------------------------------------------
+  WRITE(sub,'(a,2i0,a)')"regr",SIZE(svs),ix,"_conserv"
+  rk=assert_eq(SIZE(svs),SIZE(svt),TRIM(sub)//': inconsistent ranks')
+  WRITE(msg,'(a,2(i0,a))')TRIM(sub)//": ix (",ix,") exceeds field rank (",rk,")"
+  CALL assert(ix>=1.AND.ix<=rk,msg)
+  ii=0
+  DO is=1,rk; IF(is==ix) CYCLE
+    WRITE(msg,'(a,i0)')TRIM(sub)//" n",is
+    n=assert_eq(svs(is),svt(is),msg)
+    ii=ii+1
+  END DO
+  ns=assert_eq(svs(ix),SIZE(xs)-1,TRIM(sub)//" ns")
+  nt=assert_eq(svt(ix),SIZE(xt)-1,TRIM(sub)//" nt")
+
+  !--- Quick check on sort order:
+  CALL assert(xs(1)<xs(2), TRIM(sub)//": xs bad order")
+  CALL assert(xt(1)<xt(2), TRIM(sub)//": xt bad order")
+  CALL assert(xs(1)<=xt(1).AND.xt(nt+1)<=xs(ns+1), TRIM(sub)//": extrapolation")
+
+END SUBROUTINE check_size
+
+!-------------------------------------------------------------------------------
+
+
+END MODULE lmdz_regr_conserv
